    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------------------
    028     * AbstractSeriesDataset.java
    029     * --------------------------
    030     * (C) Copyright 2001-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 17-Nov-2001 : Version 1 (DG);
    038     * 28-Mar-2002 : Implemented SeriesChangeListener interface (DG);
    039     * 04-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    040     * 04-Feb-2003 : Removed redundant methods (DG);
    041     * 27-Mar-2003 : Implemented Serializable (DG);
    042     *
    043     */
    044
    045    package org.jfree.data.general;
    046
    047    import java.io.Serializable;
    048
    049    /**
    050     * An abstract implementation of the {@link SeriesDataset} interface,
    051     * containing a mechanism for registering change listeners.
    052     */
    053    public abstract class AbstractSeriesDataset extends AbstractDataset
    054            implements SeriesDataset, SeriesChangeListener, Serializable {
    055
    056        /** For serialization. */
    057        private static final long serialVersionUID = -6074996219705033171L;
    058
    059        /**
    060         * Creates a new dataset.
    061         */
    062        protected AbstractSeriesDataset() {
    063            super();
    064        }
    065
    066        /**
    067         * Returns the number of series in the dataset.
    068         *
    069         * @return The series count.
    070         */
    071        public abstract int getSeriesCount();
    072
    073        /**
    074         * Returns the key for a series.
    075         * <p>
    076         * If <code>series</code> is not within the specified range, the
    077         * implementing method should throw an {@link IndexOutOfBoundsException}
    078         * (preferred) or an {@link IllegalArgumentException}.
    079         *
    080         * @param series  the series index (in the range <code>0</code> to
    081         *     <code>getSeriesCount() - 1</code>).
    082         *
    083         * @return The series key.
    084         */
    085        public abstract Comparable getSeriesKey(int series);
    086
    087        /**
    088         * Returns the index of the named series, or -1.
    089         *
    090         * @param seriesKey  the series key (<code>null</code> permitted).
    091         *
    092         * @return The index.
    093         */
    094        public int indexOf(Comparable seriesKey) {
    095            int seriesCount = getSeriesCount();
    096            for (int s = 0; s < seriesCount; s++) {
    097               if (getSeriesKey(s).equals(seriesKey)) {
    098                   return s;
    099               }
    100            }
    101            return -1;
    102        }
    103
    104        /**
    105         * Called when a series belonging to the dataset changes.
    106         *
    107         * @param event  information about the change.
    108         */
    109        public void seriesChanged(SeriesChangeEvent event) {
    110            fireDatasetChanged();
    111        }
    112
    113    }